#include<bits/stdc++.h>
#define ll long long
using namespace std;
const int maxn=1e5+5;
int N,Q,niz[maxn],kol[35];
void dodaj(int a,int x){
   for(int i=0;i<=29;i++)
      if(a&(1<<i))
         kol[i]+=x;
}
void solve(){
    cin>>N;
    for(int i=1;i<=N;i++){
        cin>>niz[i];
        dodaj(niz[i],1);
    }
    int t,a,b;
    cin>>Q;
    while(Q--){
        cin>>t;
        if(t==1){
            cin>>a>>b;
            dodaj(niz[a],-1);
            niz[a]=b;
            dodaj(niz[a],1);
            continue;
        }
        cin>>a;
        int res=0;
        for(int i=0;i<=29;i++)
            if(kol[i]>=a)
               res|=(1<<i);
        cout<<res<<"\n";
    }
}
void reset(){}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int T=1;
    //cin>>T;
    while(T--){
        solve();
        reset();
    }
    return 0;
}